<?php
/*
Plugin Name: Plurkolate
Plugin URI: http://ericnakagawa.com/plurkolate
Description: Plurkolate gets your plurk feed and spits it out wherever you want... in your web page, in your sidebar... Go to the configuration page to modify your settings. BTW: I love plurk more than twitter. Though they both have their stengths and weaknesses. Yo, Plurk, reply to our emails.
Version: 1.0.6
Author: Eric Nakagawa
Author URI: http://www.ericnakagawa.com
*/
/*  Copyright 2008  Eric Nakagawa  (email : plurkolate@ericnakagawa.com)
	
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Config code and error message repuporsed from SimpleTwitter plugin: http://www.sleepydisco.co.uk/plugins/simpletwitter/

	Let's be honest... you didn't even read the GPL license, or this text... you'll scrape the code and repurpose it for your own means... no one reads EULA and GPL licenses. Right?
	
	Ideally I'd like to know if it makes it out of this plugin and into your app.

Version history:
	1.0.6 -- Added function arguments that allow user to force depth, and force whether comments show up. This is an advanced feature that gives the designer more flexibility.
	1.0.5a -- Added: 1,5,10,15, or ALL in plurks
	1.0.5 -- Auto exit on failure. Added additional verbs.
	1.0.4b -- Plurk has disabled nested plurk XML... if this happens I disable nesting.
	1.0.4a -- added css fixes, class contentions resolved
	1.0.4 -- added dutch language support -- Thank you to Patrick Andriessen (http://www.napnam.nl/) for adding Dutch language suppport
	1.0.3 --	* added nofollow for plurk-replies (limits plurk replies stealing google juice if you put this on your blog)
				* added css class for highlighting your plurks
	1.0.2a -- REALLY fixed "how many plurks to present" bug... thank you -- Manda (http://www.toxidlotus.com/)
	1.0.2 -- fixed ALL bug, added ability to show name if not using verbs, allow assigning highlight color to your plurks
	1.0.1t -- small typo fixed thanks tamar!
	1.0.1 -- support for french, german, and brazilian
	1.0b -- support for brazilian -- Thank you to Daniel Santos (http://danielsantos.org/) for adding localization support
	1.0 -- initial release
*/

$_opt_plurkusername = 'plurkolate_plurkusername';
$_opt_yourshortname = 'plurkolate_yourshortname';
$_opt_howdeep = 'plurkolate_howdeep';
$_opt_nestcomments = 'plurkolate_nestcomments';
$_opt_coloring0 = 'plurkolate_coloring0';
$_opt_coloring1 = 'plurkolate_coloring1';
$_opt_alwaysshowname = 'plurkolate_alwaysshowname';
$_opt_highlightmyplurks = 'plurkolate_highlightmyplurks';

/* Default Qualifiers *****/
$_opt_plurkolate_language = 'plurkolate_language';

$_opt_defqual_is = 'plurkolate_defqual_is';
$_opt_defqual_says = 'plurkolate_defqual_says';
$_opt_defqual_thinks = 'plurkolate_defqual_thinks';
$_opt_defqual_feels = 'plurkolate_defqual_feels';
$_opt_defqual_was = 'plurkolate_defqual_was';
$_opt_defqual_asks = 'plurkolate_defqual_asks';
$_opt_defqual_will = 'plurkolate_defqual_will';
$_opt_defqual_has = 'plurkolate_defqual_has';
$_opt_defqual_wishes = 'plurkolate_defqual_wishes';
$_opt_defqual_wants = 'plurkolate_defqual_wants';
$_opt_defqual_hates = 'plurkolate_defqual_hates';
$_opt_defqual_gives = 'plurkolate_defqual_gives';
$_opt_defqual_shares = 'plurkolate_defqual_shares';
$_opt_defqual_likes = 'plurkolate_defqual_likes';
$_opt_defqual_loves = 'plurkolate_defqual_loves';

$_opt_defqual_needs = 'plurkolate_defqual_needs';
$_opt_defqual_hopes = 'plurkolate_defqual_hopes';
$_opt_defqual_had = 'plurkolate_defqual_had';
$_opt_defqual_wonders = 'plurkolate_defqual_wonders';

/******/

function plurkolate_css() {

$coloring0 = get_option('plurkolate_coloring0');
$coloring1 = get_option('plurkolate_coloring1');

$highlightmyplurks = get_option("plurkolate_highlightmyplurks");

$is = get_option('plurkolate_defqual_is');
$says = get_option('plurkolate_defqual_says');
$thinks = get_option('plurkolate_defqual_thinks');
$feels = get_option('plurkolate_defqual_feels');
$was = get_option('plurkolate_defqual_was');
$asks = get_option('plurkolate_defqual_asks');
$will = get_option('plurkolate_defqual_will');
$has = get_option('plurkolate_defqual_has');
$wishes = get_option('plurkolate_defqual_wishes');
$wants = get_option('plurkolate_defqual_wants');
$hates = get_option('plurkolate_defqual_hates');
$gives = get_option('plurkolate_defqual_gives');
$shares = get_option('plurkolate_defqual_shares');
$likes = get_option('plurkolate_defqual_likes');
$loves = get_option('plurkolate_defqual_loves');

$needs = get_option('plurkolate_defqual_needs');
$hopes = get_option('plurkolate_defqual_hopes');
$had = get_option('plurkolate_defqual_had');
$wonders = get_option('plurkolate_defqual_wonders');


print "
<style>

li.coloring1 {background-color: " . $coloring1 . ";}
li.coloring0 {background-color: " . $coloring0 . ";}

ul.plurk, ul.plurkcomments {margin:0px;padding-left:10px;padding-bottom:5px;}
ul.plurk img, ul.plurkcomments img { vertical-align: middle; text-align:middle;}
ul.plurk li.plurklist, ul.plurkcomments li.plurkcommentslist {padding-bottom:5px;; list-style:none;} 

";
if (! ($highlightmyplurks == "")) {
print "li.myplurkcommentslist, li.myplurklist {background-color: " . $highlightmyplurks . "; }";
}
print "

.oldqualifier{padding:0 3px 0 3px;margin:0 3px 0 4px;color:white; font-size: 1.1em;}

.qualifier{padding:0 3px 0 3px;margin:0 3px 0 0px;color:white; font-size: 1.1em;}

.m_qualifier{padding:0 3px 0 3px;color:white;position:relative;}";

$plurkcss = "
.qual_menu .q_freestyle{color:#000;}
.q_is{background-color:#E57C43;}
.q_says{background-color:#E2560B;}
.q_feels,.q_needs{border-right:1px solid #304F09;border-bottom:1px solid #304F09;}
.q_needs{background-color:#7A9A37;}
.q_hopes{background-color:#e05be9;}
.q_feels{background-color:#2D83BE;}
.q_thinks{border-right:1px solid #254A64;border-bottom:1px solid #254A64;background-color:#689CC1;}
.q_wants{background-color:#8DB241;}
.q_wishes{background-color:#5BB017;}
.q_has{background-color:#777;}
.q_loves{border-right:1px solid #334E09;border-bottom:1px solid #334E09;background-color:#B20C0C;}
.q_hates{border-right:1px solid #444;border-bottom:1px solid #444;background-color:#111;}
.q_asks{border-right:1px solid #6A2C6F;border-bottom:1px solid #6A2C6F;background-color:#8361bc;}
.q_will{background-color:#B46DB9;}
.q_was{background-color:#525252;}
.q_had{background-color:#8C8C8C;}
.q_likes{background-color:#CB2728;}
.q_shares{background-color:#A74949;}
.q_gives{background-color:#620E0E;}
.q_wonders{background-color:#2e4e9e;}
.q_wants,.q_has,.q_wishes{border-right:1px solid #334C08;border-bottom:1px solid #334C08;}
.q_is,.q_says{border-right:1px solid #994215;border-bottom:1px solid #994215;}
.q_will,.q_asks,.q_hopes{border-right:1px solid #6A2C6F;border-bottom:1px solid #6A2C6F;}
.q_gives,.q_likes,.q_was,.q_wonders{border-right:1px solid #313131;border-bottom:1px solid #313131;}
.q_shares,.q_had{border-right:1px solid #454545;border-bottom:1px solid #454545;}
";

str_replace("q_is",		$is, $plurkcss);
str_replace("q_says",	$says, $plurkcss);
str_replace("q_feels",	$feels, $plurkcss);
str_replace("q_needs",	$needs, $plurkcss);
str_replace("q_hopes",	$hopes, $plurkcss);
str_replace("q_thinks",	$thinks, $plurkcss);
str_replace("q_wants",	$wants, $plurkcss);
str_replace("q_wishes",	$wishes, $plurkcss);
str_replace("q_has",	$has, $plurkcss);
str_replace("q_loves",	$loves, $plurkcss);
str_replace("q_hates",	$hates, $plurkcss);
str_replace("q_hopes",	$hopes, $plurkcss);
str_replace("q_asks",	$asks, $plurkcss);
str_replace("q_will",	$will, $plurkcss);
str_replace("q_was",	$was, $plurkcss);
str_replace("q_had",	$had, $plurkcss);
str_replace("q_likes",	$likes, $plurkcss);
str_replace("q_shares",	$shares, $plurkcss);
str_replace("q_gives",	$gives, $plurkcss);
str_replace("q_wonders",$wonders, $plurkcss);

/*
.dd_img{cursor:pointer;}
.qual_menu{font-size:16px;color:white;}
.qual_menu td{border:none!important;text-align:left;}
.qual_menu .on{background-color:black;color:white!important;}
.qual_menu .q_freestyle{color:#000;}
.q_" . $is . "{background-color:#E57C43;}
.q_" . $says . "{background-color:#E2560B;}
.q_" . $feels .",.q_" . $needs . "{border-right:1px solid #304F09;border-bottom:1px solid #304F09;}
.q_" . $needs . "{background-color:#7A9A37;}

.q_" . $feels . "{border-right:1px solid #304F09;border-bottom:1px solid #304F09;}
.q_" . $needs . "{background-color:#7A9A37;border-right:1px solid #304F09;border-bottom:1px solid #304F09;}

.q_" . $thinks . "{border-right:1px solid #254A64;border-bottom:1px solid #254A64;background-color:#689CC1;}
.q_" . $wants . "{background-color:#8DB241;}
.q_" . $wishes . "{background-color:#5BB017;}
.q_" . $has . "{background-color:#7A9A37;}
.q_" . $loves . "{border-right:1px solid #334E09;border-bottom:1px solid #334E09;background-color:#B20C0C;}
.q_" . $hates . "{border-right:1px solid #444;border-bottom:1px solid #444;background-color:#111;}
.q_" . $asks . "{border-right:1px solid #6A2C6F;border-bottom:1px solid #6A2C6F;background-color:#8361bc;}
.q_" . $will . "{background-color:#B46DB9;}
.q_" . $was . "{background-color:#525252;}
.q_" . $had . "{background-color:#8C8C8C;}
.q_" . $likes . "{background-color:#CB2728;}
.q_" . $shares . "{background-color:#A74949;}
.q_" . $gives . "{background-color:#620E0E;}
.q_" . $wants . ",.q_" . $has . ",.q_" . $wishes . "{border-right:1px solid #334C08;border-bottom:1px solid #334C08;}
.q_" . $is . ",.q_" . $says . "{border-right:1px solid #994215;border-bottom:1px solid #994215;}
.q_" . $will . ",.q_" . $asks . "{border-right:1px solid #6A2C6F;border-bottom:1px solid #6A2C6F;}
.q_" . $gives . ",." . $likes . ",.q_" . $was . "{border-right:1px solid #313131;border-bottom:1px solid #313131;}
.q_" . $shares . ",.q_" . $had . "{border-right:1px solid #454545;border-bottom:1px solid #454545;}

*/
print $plurkcss;
print "</style>";
} // end plurkolatecss()

// helper function... I despise people plugging their apps, or spam linking... this should prevent juicing them
function nofollow($str) {
	str_replace("'", "\"", $str);
	return preg_replace("/<a href=\"(.*?)\">(.*?)<\/a>/", "<a href=\"$1\" rel=\"nofollow\">$2</a>", $str);
}

function plurkolate($forcedepth = 0, $forcenesting = false) {

//$teststr = '<a href="http://plurkular.com/2008/07/07/plurkpix-lets-you-upload-pictures-to-plurk/" class="ex_link">PlurkPix</a>';
//print $teststr;
//print "\n";
//print nofollow($teststr);
//die("XXX");

// Set things all up...

$yourshortname = get_option("plurkolate_yourshortname");
$plurkusername = get_option("plurkolate_plurkusername");
$howdeep = get_option("plurkolate_howdeep");

$alwaysshowname = get_option("plurkolate_alwaysshowname");

/** Def Qualifiers ***/
$is = get_option('plurkolate_defqual_is');
$says = get_option('plurkolate_defqual_says');
$thinks = get_option('plurkolate_defqual_thinks');
$feels = get_option('plurkolate_defqual_feels');
$was = get_option('plurkolate_defqual_was');
$asks = get_option('plurkolate_defqual_asks');
$will = get_option('plurkolate_defqual_will');
$has = get_option('plurkolate_defqual_has');
$wishes = get_option('plurkolate_defqual_wishes');
$wants = get_option('plurkolate_defqual_wants');
$hates = get_option('plurkolate_defqual_hates');
$gives = get_option('plurkolate_defqual_gives');
$shares = get_option('plurkolate_defqual_shares');
$likes = get_option('plurkolate_defqual_likes');
$loves = get_option('plurkolate_defqual_loves');

$needs = get_option('plurkolate_defqual_needs');
$hopes = get_option('plurkolate_defqual_hopes');
$had = get_option('plurkolate_defqual_had');
$wonders = get_option('plurkolate_defqual_wonders');

/****/

$plurkcommentsisfunctioning = TRUE;
$plurkcommentsisdowntestranonce = FALSE; // this is to test if plurk comments is down

$nestcomments = get_option("plurkolate_nestcomments");

if ($forcedepth != 0) $howdeep = $forcedepth;
if ($forcenesting != false) { $nestcomments = 1; } else { $nestcomments = 0; }

// This will check nesting when someone selects ALL plurks... since we won't know how many items will be available in 
// the XML or if they change it this should prevent getting stuck, or crashing.
if($howdeep == 0) {$donestcheck = false;} else {$donestcheck = true;}

$ch = curl_init();
$timeout = 5; // set to zero for no timeout
curl_setopt ($ch, CURLOPT_URL, 'http://www.plurk.com/user/' . $plurkusername . '.xml');
curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
$file_contents = curl_exec($ch);
curl_close($ch);

// Plurk is down... bail
if (strpos($file_contents, "Plurk is currently unavailable")) {
	print "Plurk is down.";
	die();
}


	print "<ul class='plurk'>\n";

    $xml = simplexml_load_string  ($file_contents); 

	$xml->registerXPathNamespace("plurkolate", "http://www.w3.org/2005/Atom");

	$result = $xml->xpath("plurkolate:entry");
	
	foreach($xml->xpath('plurkolate:entry') as $item) {
	
		$row = simplexml_load_string($item->asXML());

			// determine verb
			$boom = explode(" ", $item->content, 3);

			print '<li ';
			$myplurklist = "";
			if (strtolower(trim($boom[0])) == $plurkusername) {
				$myplurklist = " myplurklist";
			}
			print 'class="plurklist' . $myplurklist . '">';
			
			if ($alwaysshowname == "yes") print $yourshortname . " ";

			switch ($boom[1]) {			
				case $is:		case $says:		case $feels:	case $thinks:
				case $wants:	case $wishes:	case $has:		case $loves:
				case $hates:	case $asks:		case $will:		case $was:
				case $had:		case $likes:	case $shares:	case $gives:
				case $hopes:	case $wonders:	case $needs:
					print '<span class="qualifier q_' . $boom[1] . '">' . $boom[1] . '</span>';
					break;

				case "<a": case "<img":
					print nofollow($boom[1]) . " ";
					break;

				default:
//					print '<span class="qualifier q_is" style="background-color: #666666; font-color: white;">' . $boom[1] . "</span>";
					print $boom[1] . " ";
					break;
			}
			print $boom[2];
			print ' <a style="font-size: .7em;" href="http://plurk.com' . $item->link->attributes() . '" rel="nofollow">plurk</a>';
			print "</li>\n";
			
				if ($nestcomments == 1 && $plurkcommentsisfunctioning) {
				
					$ch = curl_init();
					$timeout = 5; // set to zero for no timeout
					curl_setopt ($ch, CURLOPT_URL, 'http://www.plurk.com' . $item->link->attributes() . ".xml");
					curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
					curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
					$file_contents = curl_exec($ch);
					curl_close($ch);
				
					if ((!$plurkcommentsisdowntestranonce) && strpos($file_contents, "Plurk is currently unavailable") < 0) {
						print "<br />Plurk is down.";
						$plurkcommentsisfunctioning = FALSE;
						$plurkisdowntest = TRUE;
					}
				
					//http://www.plurk.com/p/lqov.xml

					print "<ul class='plurkcomments'>";
					
					    $xmlnest = simplexml_load_string  ($file_contents); 

						$xmlnest->registerXPathNamespace("plurkolatecomments", "http://www.w3.org/2005/Atom");
					
						$result = $xmlnest->xpath("plurkolatecomments:entry");

						$currentwriter = $yourshortname;
						$nestlevel = 0;
												
						foreach($xmlnest->xpath('plurkolatecomments:entry') as $nestitem) {

							$row = simplexml_load_string($item->asXML());

							// determine verb
							$nestboom = explode(" ", $nestitem->content, 3);

							if($currentwriter != $nestboom[0]) { $nestlevel++; $currentwriter = $nestboom[0]; }
							
							print '<li style="font-size:0.9em;" ';
							$myplurkcommentslist = "";
							if (strtolower(trim($nestboom[0])) == $plurkusername) {
								$myplurkcommentslist = " myplurkcommentslist";
							}
							print 'class="plurkcommentslist' . $myplurkcommentslist . ' coloring' . $nestlevel % 2 . '">';

							if(trim($nestboom[0]) == $plurkusername) {
								print $yourshortname . ' ';
							} else {
								print '<a href="http://plurk.com/user/' . $nestboom[0] . '" rel="nofollow">' . $nestboom[0] . "</a> ";
							}
							
							/* Debug test for people who reply with just images */
							//echo ($nestboom[0] . " - 0, " . $nestboom[1] . " - 1, " . $nestboom[2] . " - 2, ");

							switch ($nestboom[1]) {
								case $is:		case $says:		case $feels:	case $thinks:
								case $wants:	case $wishes:	case $has:		case $loves:
								case $hates:	case $asks:		case $will:		case $was:
								case $had:		case $likes:	case $shares:	case $gives:
								case $hopes:	case $wonders:	case $needs:
									print '<span style="font-size: 0.9em;" class="qualifier q_' . $nestboom[1];
									print '">' . $nestboom[1] . '</span>';
									break;
								case "<a": case "<img":
									print nofollow($nestboom[1]) . " ";
									break;
								default:
//									print '<span class="qualifier q_is" style="background-color: #666666;';
//									print 'font-color: white;">' . $nestboom[1] . "</span>";
									print $nestboom[1] . " ";
									break;
							}
							print nofollow($nestboom[2]);

							print "</li>\n";
						}
						
					print "</ul>\n";

				}
			if ($donestcheck && (--$howdeep) <= 0) { break; } // get out of loop
	}
	print "<li class='plurklist' style='text-align:right;'>Add <a href='http://www.plurk.com/user/" . $plurkusername . "' rel='nofollow'>" . $plurkusername . "</a> as a friend.<br /><a href='http://www.plurkolate.com'>Plurkolate - A Plurk plugin for Wordpress</a></li>";
	print "</ul>";
} // end plurkolate()

// Displays a warning message when cURL isn't available
function _show_plurkolate_curl_warning() {
	?>
<div class="error">
<h3>Plurkolate needs the php cURL library to be installed</h3>
<p>Plurkolate uses the cURL php library to connect to the Plurk website. 
This doesn't seem to be available with your current php configuration - it has 
possibly been disabled in your php.ini file.<br /><br />Please contact your 
System Administrator or Service Provider for information.</p>
</div>	
	<?php
}

add_action('admin_menu', 'add_plurkolate_options');

// Options hook -- what the hook gon' be?
function add_plurkolate_options() {
    if (function_exists('add_options_page')) {
		add_options_page('Plurkolate', 'Plurkolate', 8, 'plurkolate', 'plurkolate_options_subpanel');
    }
}
 
// Options panel and form processing
function plurkolate_options_subpanel() {
	echo "<h2>Plurkolate</h2>";

	if (!function_exists('curl_init')) {
		_show_plurkolate_curl_warning();	
	}
	else {
		if (isset($_POST['info_update'])) {
			global $_opt_plurkusername;
			global $_opt_yourshortname;
			global $_opt_howdeep;
			global $_opt_nestcomments;
			global $_opt_coloring0;
			global $_opt_coloring1;
			
			global $_opt_alwaysshowname;
			global $_opt_highlightmyplurks;
			
			/** Def qualifiers **/
			global $_opt_defqual_is;
			global $_opt_defqual_says;
			global $_opt_defqual_thinks;
			global $_opt_defqual_feels;
			global $_opt_defqual_was;
			global $_opt_defqual_asks;
			global $_opt_defqual_will;
			global $_opt_defqual_has;
			global $_opt_defqual_wishes;
			global $_opt_defqual_wants;
			global $_opt_defqual_hates;
			global $_opt_defqual_gives;
			global $_opt_defqual_shares;
			global $_opt_defqual_likes;
			global $_opt_defqual_loves;

			global $_opt_defqual_needs;
			global $_opt_defqual_hopes;
			global $_opt_defqual_had;
			global $_opt_defqual_wonders;
			
			global $_opt_plurkolate_language;
	
			$plurkusername = $_POST['plurkusername'];
			$yourshortname = $_POST['yourshortname'];
			$howdeep = $_POST['howdeep'];
			$nestcomments = $_POST['nestcomments'];
			$coloring0 = $_POST['coloring0'];
			$coloring1 = $_POST['coloring1'];
			$language = $_POST['language'];
			$alwaysshowname = $_POST['alwaysshowname'];
			$highlightmyplurks = $_POST['highlightmyplurks'];
			
			if (!preg_match('/#[0-9a-fA-F]{6}/', $coloring0)) {$coloring0 = "#e3e3e3";}
			if (!preg_match('/#[0-9a-fA-F]{6}/', $coloring1)) {$coloring1 = "#f0f0f0";}
			if (!preg_match('/#[0-9a-fA-F]{6}/', $highlightmyplurks)) {$highlightmyplurks = "";}

			switch ($language) {
				case 'ar':
					break;
				case 'pt_BR':
					$is = 'está';				$says = 'diz';		$thinks = 'pensa';	$feels = 'sente';
					$was = 'estava';			$asks = 'pergunta';	$will = 'vai';		$has = 'tem';
					$wishes = 'deseja';			$wants = 'quer';	$hates = 'odeia';	$gives = 'dá';
					$shares = 'compartilha';	$likes = 'gosta';	$loves = 'ama';
					break;
				case 'cn':
					break;
				case 'tr_ch':
					break;
				case 'dk':
					break;
				case 'ne':
					$is = 'is';				$says = 'zegt';			$thinks = 'denkt';	$feels = 'voelt';
					$was = 'was';			$asks = 'vraagt';		$will = 'zal';		$has = 'heeft';
					$wishes = 'hoopt';		$wants = 'wil';			$hates = 'haat';	$gives = 'geeft';
					$shares = 'verstuurt';	$likes = 'houdt van';	$loves = 'is wild van';
					break;
				case 'fi':
					break;
				case 'fr':
					$is = 'est';			$says = 'dit';			$thinks = 'pense';	$feels = 'se sent';
					$was = 'était';			$asks = 'demande';		$will = 'va';		$has = 'a';
					$wishes = 'souhaite';	$wants = 'veut';		$hates = 'déteste';	$gives = 'donne';
					$shares = 'partage';	$likes = 'apprécie';	$loves = 'aime';
					break;
				case 'de':
					$is = 'ist';			$says = 'sagt';		$thinks = 'denkt';	$feels = 'fühlt';
					$was = 'war';			$asks = 'fragt';	$will = 'wird';		$has = 'hat';
					$wishes = 'wünscht';	$wants = 'will';	$hates = 'hasst';	$gives = 'gibt';
					$shares = 'teilt';		$likes = 'mag';		$loves = 'liebt';
					break;
				case 'hu':
					break;
				case 'in':
					break;
				case 'it':
					break;
				case 'pl':
					break;
				case 'ru':
					break;
				case 'es':
					break;
				case 'ta_fp':
					break;
				case 'en':
				default:
					$is = 'is';			$says = 'says';		$thinks = 'thinks';	$feels = 'feels';
					$was = 'was';		$asks = 'asks';		$will = 'will';		$has = 'has';
					$wishes = 'wishes';	$wants = 'wants';	$hates = 'hates';	$gives = 'gives';
					$shares = 'shares';	$likes = 'likes';	$loves = 'loves';	$needs = 'needs';
					$hopes = 'hopes';	$had = 'had';		$wonders = 'wonders';
			}

			update_option($_opt_plurkusername, $plurkusername);
			update_option($_opt_yourshortname, $yourshortname);
			update_option($_opt_howdeep, $howdeep);
			update_option($_opt_nestcomments, $nestcomments);

			update_option($_opt_coloring0, $coloring0);
			update_option($_opt_coloring1, $coloring1);
			
			update_option($_opt_alwaysshowname, $alwaysshowname);
			update_option($_opt_highlightmyplurks, $highlightmyplurks);

			update_option($_opt_plurkolate_language, $language);

			/* Def Qualifiers */
			update_option($_opt_defqual_is, $is);
			update_option($_opt_defqual_says, $says);
			update_option($_opt_defqual_thinks, $thinks);
			update_option($_opt_defqual_feels, $feels);
			update_option($_opt_defqual_was, $was);
			update_option($_opt_defqual_asks, $asks);
			update_option($_opt_defqual_will, $will);
			update_option($_opt_defqual_has, $has);
			update_option($_opt_defqual_wishes, $wishes);
			update_option($_opt_defqual_wants, $wants);
			update_option($_opt_defqual_hates, $hates);
			update_option($_opt_defqual_gives, $gives);
			update_option($_opt_defqual_shares, $shares);
			update_option($_opt_defqual_likes, $likes);
			update_option($_opt_defqual_loves, $loves);

			update_option($_opt_defqual_needs, $needs);
			update_option($_opt_defqual_hopes, $hopes);
			update_option($_opt_defqual_had, $had);
			update_option($_opt_defqual_wonders, $wonders);

		}
		_show_plurkolate_form();
	}
}

// Displays a form to edit configuration options
function _show_plurkolate_form() {
	?>
<div class="wrap">
<form method="post">
<fieldset class="options">
<legend><?php _e('Setup Plurkolate') ?></legend>
<table width="100%" cellspacing="2" cellpadding="5" class="editform"> 
<tr valign="top"> 
<th width="33%" scope="row" align="right"><label for="plurkusername"><?php _e('Your Plurk username:') ?></label></th> 
<td><input type="text" name="plurkusername" id="plurkusername" value="<?php form_option('plurkolate_plurkusername'); ?>"/></td> 
</tr>

<tr valign="top">
<th scope="row" align="right"><label for="yourshortname"><?php _e('Your nickname (used when nesting):') ?></label></th>
<td><input type="text" name="yourshortname" id="yourshortname" size="10" value="<?php form_option('plurkolate_yourshortname'); ?>"/></td>
</tr> 

<tr valign="top">
<th scope="row" align="right"><label for="alwaysshowname"><?php _e("Always show your nickname?<br>(for folks who don't use verbs in plurks):") ?></label></th>
<td>Yes <input type="radio" name="alwaysshowname" id="alwaysshowname" value="yes" <?php if (get_option('plurkolate_alwaysshowname') == "yes") { _e('checked'); }?>/> No <input type="radio" name="alwaysshowname" id="alwaysshowname" value="no" <?php if (get_option('plurkolate_alwaysshowname') == "no") { _e('checked'); }?>/></td>
</tr> 

<tr valign="top">
<th scope="row" align="right"><label for="howdeep"><?php _e('How many Plurks to present:') ?></label></th>
<td>
	<select name="howdeep" size="1">
	  <option value="0" <?php if (get_option('plurkolate_howdeep') == 0) { _e('selected'); }?>>ALL</option>
	  <option value="15" <?php if (get_option('plurkolate_howdeep') == 15) { _e('selected'); }?>>15</option>
	  <option value="10" <?php if (get_option('plurkolate_howdeep') == 10) { _e('selected'); }?>>10</option>
	  <option value="5" <?php if (get_option('plurkolate_howdeep') == 5) { _e('selected'); }?>>5</option>
	  <option value="1" <?php if (get_option('plurkolate_howdeep') == 1) { _e('selected'); }?>>1</option>
	</select>
</td>
</tr> 

<tr valign="top">
<th scope="row" align="right"><label for="nestcomments"><?php _e('Show comments from your Plurks?<br>(show the conversation):') ?></label></th>
<td>Yes <input type="radio" name="nestcomments" id="nestcomments" value="1"  <?php if (get_option('plurkolate_nestcomments') == 1) { _e('checked'); }?>/> No <input type="radio" name="nestcomments" id="nestcomments" value="0"  <?php if (get_option('plurkolate_nestcomments') == 0) { _e('checked'); }?>/></td>
</tr> 

<tr valign="top">
<th scope="row" align="right"><label for="highlightmyplurks"><?php _e('Highlight your Plurks with background color?<br>(make your replies easier to find):') ?></label></th>
<td><input type="text" name="highlightmyplurks" id="highlightmyplurks" size="10" value="<?php form_option('plurkolate_highlightmyplurks'); ?>"/></td>
</tr> 

<tr valign="top">
<th scope="row" align="right"><label for="language"><?php _e('Choose your language:') ?></label></th>
<td>
<select name="language" id="language">
	<option value="en" <?php if (get_option('plurkolate_language') == 'en') { _e('selected'); }?>>English</option>
	<option value="ar" disabled <?php if (get_option('plurkolate_language') == 'ar') { _e('selected'); }?>>Arabic</option>
	<option value="pt_BR" <?php if (get_option('plurkolate_language') == 'pt_BR') { _e('selected'); }?>>Brazilian Portuguese</option>
	<option value="cn" disabled <?php if (get_option('plurkolate_language') == 'cn') { _e('selected'); }?>>Chinese (Simplified)</option>
	<option value="tr_ch" disabled <?php if (get_option('plurkolate_language') == 'tr_ch') { _e('selected'); }?>>Chinese (Traditional)</option>
	<option value="dk" disabled <?php if (get_option('plurkolate_language') == 'dk') { _e('selected'); }?>>Danish</option>
	<option value="ne" <?php if (get_option('plurkolate_language') == 'ne') { _e('selected'); }?>>Dutch</option>
	<option value="fi" disabled <?php if (get_option('plurkolate_language') == 'fi') { _e('selected'); }?>>Finnish</option>
	<option value="fr" <?php if (get_option('plurkolate_language') == 'fr') { _e('selected'); }?>>French</option>
	<option value="de" <?php if (get_option('plurkolate_language') == 'de') { _e('selected'); }?>>German</option>
	<option value="hu" disabled <?php if (get_option('plurkolate_language') == 'hu') { _e('selected'); }?>>Hungarian</option>
	<option value="in" disabled <?php if (get_option('plurkolate_language') == 'in') { _e('selected'); }?>>Indonesian</option>
	<option value="it" disabled <?php if (get_option('plurkolate_language') == 'it') { _e('selected'); }?>>Italian</option>
	<option value="pl" disabled <?php if (get_option('plurkolate_language') == 'pl') { _e('selected'); }?>>Polish</option>
	<option value="ru" disabled <?php if (get_option('plurkolate_language') == 'ru') { _e('selected'); }?>>Russian</option>
	<option value="es" disabled <?php if (get_option('plurkolate_language') == 'es') { _e('selected'); }?>>Spanish</option>
	<option value="ta_fp" disabled <?php if (get_option('plurkolate_language') == 'ta_fp') { _e('selected'); }?>>Tagalog/Filipino</option>
</select>
</td>
</tr>

<tr valign="top">
<th scope="row" align="right"><label for="coloring0"><?php _e('Color for odd numbered comments:') ?></label></th>
<td><input type="text" name="coloring0" id="coloring0" size="10" value="<?php form_option('plurkolate_coloring0'); ?>"/></td>
</tr> 
<tr valign="top">
<th scope="row" align="right"><label for="coloring1"><?php _e('Color for even numbered comments:') ?></label></th>
<td><input type="text" name="coloring1" id="coloring1" size="10" value="<?php form_option('plurkolate_coloring1'); ?>"/></td>
</tr> 
</table> 
<p class="submit">
<input type="submit" name="info_update" value="<?php _e('Update Options') ?> &raquo;" />
</p>
</fieldset>
</form>
</div>
	<?php
}

add_action('wp_head', 'plurkolate_css');

/*
function widget_plurkolate($args) {

	if (!function_exists('register_sidebar_widget')) return;

        echo $before_widget;
        echo $before_title
			. 'Plurkolate'
			. $after_title; 
		//plurkolate();
		echo $after_widget;
}

add_action('widgets_init', 'widget_plurkolate');
register_sidebar_widget('plurk', 'widget_plurkolate');
*/

?>